/******************************************************************************
 * Copyright (C) 2006 Tetsuya Kimata <kimata@acapulco.dyndns.org>
 *
 * All rights reserved.
 *
 * This software is provided 'as-is', without any express or implied
 * warranty.  In no event will the authors be held liable for any
 * damages arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any
 * purpose, including commercial applications, and to alter it and
 * redistribute it freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software. If you use this
 *    software in a product, an acknowledgment in the product
 *    documentation would be appreciated but is not required.
 *
 * 2. Altered source versions must be plainly marked as such, and must
 *    not be misrepresented as being the original software.
 *
 * 3. This notice may not be removed or altered from any source
 *    distribution.
 *
 * $Id: ShmCommentIterator.h 1981 2006-11-12 06:40:26Z svn $
 *****************************************************************************/

#ifndef SHM_COMMENT_ITERATOR_H
#define SHM_COMMENT_ITERATOR_H

#include "Environment.h"

#include <cstdlib>

#include "AtomicWrapper.h"

#include "BBSCommentIterator.h"
#include "ReadLocker.h"
#include "Uncopyable.h"

using namespace std;

class BBSThread;

/**
 * @brief コメントの読み出しを行うクラス．
 *
 * コンストラクタとデストラクタで例外が発生する可能性があるので，取り扱
 * いには注意が必要です．
 */
class ShmCommentIterator: public BBSCommentIterator
{
public:
    ShmCommentIterator(BBSThread *bbs_thread,
                       apr_atomic_t *lock_count,
                       BBSCommentIterator::range_t *ranges=NULL,
                       apr_size_t range_count=0);

private:
    ReadLocker locker_;
};

#endif

// Local Variables:
// mode: c++
// coding: utf-8-dos
// End:
